<template>
  <div class="content">
    <div class="intro-y flex flex-col sm:flex-row items-center my-8">
      <div class="mr-auto">
        <h2 class="text-lg font-medium mr-auto">Form Event</h2>
      </div>
    </div>
    <div class="grid grid-cols-12 gap-6 mt-5">
      <div class="intro-y col-span-12 lg:col-span-6">
        <!-- BEGIN: Form Layout -->
        <div class="intro-x box p-5">
          <form @submit.prevent="submit">
            <div>
              <label for="crud-form-1" class="form-label">Name</label>
              <input id="crud-form-1" type="text" class="form-control w-full" v-model="name" placeholder="Input Name" />
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Category</label>
              <select class="tom-select w-full" v-model="category" data-placeholder="Select Category">
                <option v-for="item in categories" :value="item" :key="item" :selected="item === category">
                  {{ item }}
                </option>
              </select>
            </div>
            <div v-show="!edit">
              <label for="crud-form-1" class="form-label mt-2">Category Schedule</label>
              <select class="tom-select w-full" v-model="category_schedule" data-placeholder="Select Category">
                <option v-for="item in categories_schedule" :value="item" :key="item"
                  :selected="item === category_schedule">
                  {{ item }}
                </option>
              </select>
            </div>
            <div v-show="!edit">
              <label for="crud-form-1" class="form-label mt-2">Event Date</label>
              <Datepicker v-model="event_date" class="form-control" placeholder="Event Date ..." textInput range />
            </div>

            <div>
              <label for="crud-form-1" class="form-label mt-2">Category Location</label>
              <select class="tom-select w-full" v-model="category_location" data-placeholder="Select Category">
                <option v-for="item in categories_location" :value="item" :key="item"
                  :selected="item === category_location">
                  {{ item }}
                </option>
              </select>
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Room</label>
              <input id="crud-form-1" type="text" class="form-control w-full" v-model="room" placeholder="Input Room" />
            </div>
            <div v-if="category_location != 'offline'">
              <label for="crud-form-1" class="form-label mt-2">Link Meeting</label>
              <input id="crud-form-1" type="text" class="form-control w-full" v-model="link"
                placeholder="Input Link Meeting" />
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Organizer</label>
              <input type="text" class="form-control w-full" v-model="organizer" disabled v-if="this.$store.state.user.user.role != 'superadmin'"/>
              <select class="tom-select w-full" v-model="organizer" data-placeholder="Select Organizer" v-else>
                <option v-for="item in organizers" :value="item" :key="item">
                  {{ item }}
                </option>
              </select>
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Department</label>
              <TomSelect class="tom-select w-full" v-model="department" data-placeholder="Select Department" multiple>
                <option v-for="item in departments" :value="item" :key="item">
                  {{ item }}
                </option>
              </TomSelect>
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Level</label>
              <TomSelect class="tom-select w-full" v-model="jabatan" data-placeholder="Select Jabatan" multiple>
                <option v-for="item in jabatans" :value="item.value" :key="item.value">
                  {{ item.display }}
                </option>
              </TomSelect>
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Participant</label>
              <TomSelect class="w-full" v-model="participant" data-placeholder="Select Participant" multiple>
                <option v-for="item in users" :value="item" :key="item">
                  {{ item }}
                </option>
              </TomSelect>
            </div>
            <div>
              <label for="crud-form-1" class="form-label mt-2">Need Support</label>
              <TomSelect class="tom-select w-full" v-model="support" data-placeholder="Select Level" multiple>
                <option v-for="item in supports" :value="item" :key="item">
                  {{ item }}
                </option>
              </TomSelect>
            </div>
            <!-- <div>
              <label for="crud-form-1" class="form-label mt-1">Attachment</label>
              <input id="crud-form-1" type="file" class="form-control w-full" ref="file"
                v-on:change="handleFileUpload()" />
            </div> -->
            <div>
              <label for="crud-form-1" class="form-label mt-1">Note</label>
              <textarea v-model="note" class="from-control w-full" rows="4" placeholde="Input Note"></textarea>
            </div>
            <div class="text-right mt-5">
              <a type="button" class="btn btn-outline-secondary w-24 mr-1" href="/event">
                Cancel
              </a>
              <button type="submit" class="btn btn-primary w-24">
                {{ label }}
              </button>
            </div>
          </form>
        </div>
        <!-- END: Form Layout -->
      </div>
    </div>
  </div>
</template>

<script>
  import Toastify from "toastify-js";
  import axios from "axios";


  export default {
    name: "FormEvent",
    data() {
      return {
        file: "",
        name: "",
        event: {},
        category: "",
        category_schedule: "",
        categories_schedule: ["Yearly", "Monthly", "Weekly", "Tidak Rutin", "Full Day"],
        categories: [],
        organizer: "",
        organizers: [],
        department: [],
        departments: ["Undang Semua"],
        jabatan: [],
        jabatans: [{
          value : "pilih semua",
          display : "Pilih Semua"
        }],
        category_location: "",
        categories_location: [
          "online",
          "offline",
          "offline_online"
        ],
        room: "",
        link: "",
        event_date: "",
        duration: "",
        note: "",
        supports: [],
        support: [],
        pic: "",
        edit: false,
        users: [],
        participant: [],
        fieldEmpty: [],
        error: "",
        label: "Save",
        id: 0,
      };
    },
    watch: {
      department() {
        // this.getJabatan();
        // console.log(this.department)
        const idx = this.department.indexOf("Undang Semua")

        if (this.department.find(x => x != "Undang Semua") && idx > -1) {
          this.department.splice(idx,1)
        }
        this.getUser();  
      },
      jabatan(){
        const idx = this.jabatan.indexOf("pilih semua")

        if (this.jabatan.find(x => x != "pilih semua") && idx > -1) {
          this.jabatan.splice(idx,1)
        }
        this.getUser();
      }
    },
    created: function () {
      var splitUrl = this.$route.path.split("/");
      if (splitUrl[1] == "edit-event") {
        this.edit = true;
        this.id = splitUrl[2];
        this.label = "Edit";
      }
    },
    methods: {
      async getOrganizer() {
        const res = await this.$axios.get("/organizer/code", {
          headers: {
            Token: this.$store.state.user.token,
            "User-ID": this.$store.state.user.user_id,
          },
        });
        let data = res.data.data;

        for (let x = 0; x < data.length; x++) {
          const element = data[x];
          this.organizers.push(element.name);
          this.departments.push(element.name);
        }
      },
      async getCategory() {
        const res = await this.$axios.get("/category/code", {
          headers: {
            Token: this.$store.state.user.token,
            "User-ID": this.$store.state.user.user_id,
          },
        });
        let data = res.data.data;

        for (let x = 0; x < data.length; x++) {
          const element = data[x];
          this.categories.push(element.name);
        }
      },
      async getJabatan() {
        const res = await this.$axios.get("/role/code", {
          headers: {
            Token: this.$store.state.user.token,
            "User-ID": this.$store.state.user.user_id,
          },
        });
        let data = res.data.data;

        for (let x = 0; x < data.length; x++) {
          const element = data[x];
          this.jabatans.push({
              value : element.name,
              display :element.name 
            });
        }
        // let department = ""
        // const founded = this.department.find(x => {
        //   return x == "Undang Semua"
        // })
        // if (founded) {  
        //   department = this.departments.toString()
        //   department = department.replace("Undang Semua,","") 
        // }else{
        //   department = this.department ? this.department.toString() : ""
        // }
        
        // if (department != "") {
        //   const query = {
        //     department: department,
        //   };
        //   const res = await axios.get("http://127.0.0.1:8000/api/listjabatan", {
        //     params: query,
        //   });
        //   let data = res.data;
          
        //   for (let x = 0; x < data.length; x++) {
        //     const element = data[x];
            // this.jabatans.push({
            //   value : element.intidjabatan,
            //   display :element.txtnamajabatan 
            // });
        //   }
        // }
      },
      async getUser() {
        let department = ""
        let jabatan = ""

        const founded = this.department.find(x => {
          return x == "Undang Semua"
        })
        if (founded) {  
          department = this.departments.toString()
          department = department.replace("Undang Semua,","") 
        }else{
          department = this.department ? this.department.toString() : ""
        }

        const foundedJabatan = this.jabatan.find(x => {
          return x == "pilih semua"
        })
        if (foundedJabatan) {
          jabatan = this.jabatans.reduce((newValue,jabatan) => {
            newValue += `${jabatan.value},`

            return newValue
          },"")  
          jabatan = jabatan.replace("pilih semua,","")
           
        }else{
          jabatan = this.jabatan.reduce((newValue,jabatan) => {
            newValue += `${jabatan},`

            return newValue
          },"")  
        }

        jabatan = jabatan.slice(0, -1)

        if (department != "" || jabatan != "") {
          const query = {
            organizer: department,
            level   : jabatan
          };

          const res = await this.$axios.get("/participant/code", {
            params : query,
            headers: {
              Token: this.$store.state.user.token,
              "User-ID": this.$store.state.user.user_id,
            },
          });
          let data = res.data.data;
          this.users = []

          if (data.length > 0) {
            this.users.push("Undang Semua")
          }
          for (let x = 0; x < data.length; x++) {
            const element = data[x];
            // this.organizers.push(element.name);
            // this.departments.push(element.name);

            this.users.push(`${element.id} - ${element.name}`);
          }
          // const res = await axios.get("http://127.0.0.1:8000/api/listkaryawan", {
          //   params: query,
          // });
          // let data = res.data.data;
          
          // for (let x = 0; x < data.length; x++) {
          //   const element = data[x].attributes;
          //   this.users.push(`${element.fullname}-${element.username}`);
          // }
        }
      },
      async getSupport() {
        const res = await axios.get("http://127.0.0.1:8000/api/jenisrequest");
        let data = res.data.data;
        for (let x = 0; x < data.length; x++) {
          const element = data[x].attributes;
          this.supports.push(element.Value);
        }
      },
      handleFileUpload() {
        this.file = this.$refs.file.files[0];
      },
      async getDetail() {
        this.$axios
          .get(`/event/${this.id}/detail`, {
            headers: {
              Token: this.$store.state.user.token,
              "User-ID": this.$store.state.user.user_id,
            },
          })
          .then((response) => {
            const data = response.data.data;
            console.log("DATA")
            console.log(data.departments)
            const dp = data.departments
            this.event = data
            this.name = data.name;
            this.category = data.category_event.name;
            this.organizer = data.organizer;
            this.department = dp ? dp : [];
            this.jabatan = data.level ? data.level : [];
            console.log(this.department)
            if (data.category_event.link != "") {
              this.category_location = "online";
            } else {
              this.category_location = "offline";
            }

            this.getUser()
            this.room = data.category_event.room;
            this.link = data.category_event.link;
            
            const participant = data.participant_event;
            const participantUser = participant.map((x) => {
              return `${x.name}-${x.username}`
            });
            
            this.participant = participantUser;
            this.support = data.support.list_item;
            this.pic = data.support.pic;
            this.note = data.note;
          })
          .catch((error) => {
            console.log(error);
          });
      },
      reset() {
        this.name = this.event ? this.event.name : "";
        this.category = this.event.category_event ? this.event.category_event.name : "";
        this.organizer = this.event ? this.event.organizer : "";
        this.department = this.event ? this.event.department : [];
        if (this.event.category_event) {
          this.category_location = this.event.category_event.link != "" ? "online" : "offline";
        } else {
          this.category_location = "offline";
        }

        this.room = this.event.category_event ? this.event.category_event.room : "";
        this.link = this.event.category_event ? this.event.category_event.link : "";
        const participant = this.event.participant_event ? this.event.participant_event : [];
        const participantUser = participant.map((x) => {
          return `${x.name}-${x.username}`
        });
        this.participant = participantUser;
        this.support = this.event.support ? this.event.support.list_item : [];
        this.pic = this.event.support ? this.event.support.pic : "";
        this.note = this.event ? this.event.note : "";
        this.event_date = []
      },
      submit: function () {
        let formData = new FormData();
        let startDate,
          endDate,
          timeStart,
          timeEnd = "";

        const allInvite = this.participant.find(x => {
          return x == 'Undang Semua'
        })

        if (allInvite) {
          const myIndex = this.users.indexOf('Undang Semua');
          this.participant = this.users
          this.participant.splice(myIndex, 1);
        }

        if (!this.edit) {
          const formaStartDate = new Date(this.event_date[0]);
          const startYear = formaStartDate.getUTCFullYear();
          const startMonth =
            formaStartDate.getUTCMonth() + 1 > 9 ?
            (formaStartDate.getUTCMonth() + 1).toString() :
            "0" + (formaStartDate.getUTCMonth() + 1).toString();
          const startDay =
            formaStartDate.getUTCDate() > 9 ?
            formaStartDate.getUTCDate().toString() :
            "0" + formaStartDate.getUTCDate().toString();

          const startHour =
            formaStartDate.getHours() < 10 ?
            "0" + formaStartDate.getHours() :
            formaStartDate.getHours();
          const startMinute =
            formaStartDate.getMinutes() < 10 ?
            "0" + formaStartDate.getMinutes() :
            formaStartDate.getMinutes();

          startDate = `${startYear}-${startMonth}-${startDay}`;
          timeStart = this.category_schedule == 'Full Day' ? '08:00:00' : `${startHour}:${startMinute}:00`;

          if (this.event_date.length > 1) {

            if (this.event_date[1] == null) {
              endDate = startDate;
              timeEnd = this.category_schedule == 'Full Day' ? '16:30:00' : timeStart;
            } else {
              const FormatendDate = new Date(this.event_date[1]);
              const endYear = FormatendDate.getUTCFullYear();
              const endMonth =
                FormatendDate.getUTCMonth() + 1 > 9 ?
                (FormatendDate.getUTCMonth() + 1).toString() :
                "0" + (FormatendDate.getUTCMonth() + 1).toString();
              const endDay =
                FormatendDate.getUTCDate() > 9 ?
                FormatendDate.getUTCDate().toString() :
                "0" + FormatendDate.getUTCDate().toString();

              const endHour =
                FormatendDate.getHours() < 10 ?
                "0" + FormatendDate.getHours() :
                FormatendDate.getHours();
              const endMinute = FormatendDate.getMinutes() ?
                "0" + FormatendDate.getMinutes() :
                FormatendDate.getMinutes();

              endDate =
                this.event_date.length > 1 ?
                `${endYear}-${endMonth}-${endDay}` :
                startDate;

              timeEnd = this.category_schedule == 'Full Day' ? '16:30:00' : `${endHour}:${endMinute}:00`;
            }

          } else {
            endDate = startDate;
            timeEnd = this.category_schedule == 'Full Day' ? '16:30:00' : timeStart;
          }
        }
        
        formData.append("name", this.name);
        formData.append("category", this.category);
        formData.append("organizer", this.organizer);
        formData.append("room", this.room);
        formData.append("link", this.link);
        formData.append("department", this.department.toString());
        formData.append("jabatan",this.jabatan.toString());
        if (!this.edit) {
          formData.append("start_date", startDate);
          formData.append("end_date", endDate);
          formData.append("start_time", timeStart);
          formData.append("end_time", timeEnd);
        }
        formData.append("participant", this.participant.toString());
        formData.append("support", this.support.toString());
        // formData.append("attachment", this.file);
        formData.append("note", this.note);

        if (this.name == "") {
          Toastify({
            text: `ERROR : name is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.category == "") {
          Toastify({
            text: `ERROR : category is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.organizer == "") {
          Toastify({
            text: `ERROR : orgnizer is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.room == "") {
          Toastify({
            text: `ERROR : room is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.department == "") {
          Toastify({
            text: `ERROR : department is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (startDate == "" || endDate == "") {
          Toastify({
            text: `ERROR : start date and end date is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.participant.length == 0) {
          Toastify({
            text: `ERROR : participant is empty`,
            duration: 3000,
            newWindow: true,
            close: true,
            gravity: "top",
            position: "right",
            stopOnFocus: true,
            className: "toastify-content",
          }).showToast();

          return
        }

        if (this.edit) {
          this.$axios
            .put(`/event/${this.id}/update`, formData, {
              headers: {
                "Content-Type": "multipart/form-data",
                Token: this.$store.state.user.token,
                "User-ID": this.$store.state.user.user_id,
              },
            })
            .then(() => {
              Toastify({
                text: `Update Event Success`,
                duration: 3000,
                newWindow: true,
                close: true,
                gravity: "top",
                position: "right",
                stopOnFocus: true,
                className: "toastify-content",
              }).showToast();
              this.$router.push({
                name: "data-event",
              });
            })
            .catch((error) => {
              Toastify({
                text: `ERROR : ${error.response.data.message}`,
                duration: 3000,
                newWindow: true,
                close: true,
                gravity: "top",
                position: "right",
                stopOnFocus: true,
                className: "toastify-content",
              }).showToast();
            });
        } else {
          this.$axios
            .post("/event", formData, {
              headers: {
                "Content-Type": "multipart/form-data",
                Token: this.$store.state.user.token,
                "User-ID": this.$store.state.user.user_id,
              },
            })
            .then(() => {
              Toastify({
                text: `Create Event Success`,
                duration: 3000,
                newWindow: true,
                close: true,
                gravity: "top",
                position: "right",
                stopOnFocus: true,
                className: "toastify-content",
              }).showToast();
              this.$router.push({
                name: "data-event",
              });
            })
            .catch((error) => {
              Toastify({
                text: `ERROR : ${error.response.data.message}`,
                duration: 3000,
                newWindow: true,
                close: true,
                gravity: "top",
                position: "right",
                stopOnFocus: true,
                className: "toastify-content",
              }).showToast();
            });
        }
      },
    },
    mounted() {
      if (this.$store.state.user.user.role != "superadmin") {
        this.organizer = this.$store.state.user.user.department
      }
      this.getOrganizer();
      this.getCategory();
      this.getSupport();
      this.getJabatan();
      if (this.edit) {
        this.getDetail();
      }
    },
  };
</script>